chan request = [2] of { byte, chan}; 
chan reply[5] = [2] of { byte };

byte x = 4;

active [2] proctype Server() { 
  byte client; 
  chan replyChannel; 

  do
     :: request ? client, replyChannel -> 
        printf("Client %d processed by server %d\n", client, _pid); 
        replyChannel ! _pid
  od
}

proctype Client(byte me) { 
  byte server;
  do 
    :: nfull(request) -> printf("Client %d idle\n", me); // Not really needed
    :: request ! me, reply[me] ; 
       reply[me] ? server;
       printf("My (%d) request was processed by server %d\n", me, server)    
  od
}

init {
  byte i = 0;
  do
    :: i == 5 -> break
    :: else ->
       run Client(i);
       i = i + 1
  od
}
